<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99f                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//check if the script is not included... if so: stop the execution
if(!defined('_phpipblocker_dir_'))
	die("You can't access this file!");

//START SCRIPT CODE
if(!@require_once(_phpipblocker_dir_."functions.php"))
	die("Unable to include <b>funtions.php</b>... cannot proceed... check the <b>\"phpipblocker_dir\"</b> is correctly setted");
if(!@require_once(_phpipblocker_dir_."config.php"))
	die("Unable to include <b>config.php</b>... cannot proceed... check the <b>\"phpipblocker_dir\"</b> is correctly setted");

//security addon
unset($ipblocker_ban);

//find ip & hostname
$ipblocker_ban['ip'] = $_SERVER['REMOTE_ADDR'];
$ipblocker_ban['ip_coded'] = sprintf("%u", ip2long($ipblocker_ban['ip']));
$ipblocker_ban['hostname'] = gethostbyaddr($ipblocker_ban['ip']);

//proxy vars inizialization
$ipblocker_ban['using_proxy'] = false;
$ipblocker_ban['forwaded_for_ip'] = "";
$ipblocker_ban['forwaded_for_hostname'] = "";

//start transparent proxy check
if($ipblocker_config['proxyCheck'] && isset($_SERVER['HTTP_X_FORWARDED_FOR'])){
	$ipblocker_ban['forwaded_for_ip'] = strtolower($_SERVER['HTTP_X_FORWARDED_FOR']);
	//control if the format is correct (xxx.xxx.xxx.xxx)
	if(!eregi("^([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})$", $ipblocker_ban['forwaded_for_ip']))
		$ipblocker_ban['forwaded_for_ip'] = "";
	if(!empty($ipblocker_ban['forwaded_for_ip'])){
		$ipblocker_ban['forwaded_for_ip_coded'] = sprintf("%u", ip2long($ipblocker_ban['forwaded_for_ip']));
		//control if the ip forwaded_for is a private address
		//if((sprintf("%u", ip2long("0.0.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("0.255.255.255"))) || (sprintf("%u", ip2long("10.0.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("10.255.255.255"))) || (sprintf("%u", ip2long("192.168.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("192.168.255.255"))) || (sprintf("%u", ip2long("240.0.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("255.255.255.255"))) || (sprintf("%u", ip2long("127.0.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("127.255.255.255"))) || (sprintf("%u", ip2long("172.16.0.0"))<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<sprintf("%u", ip2long("172.31.255.255"))))
		if((0<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<16777215) || (167772160<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<184549375) || (3232235520<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<3232301055) || (4026531840<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<4294967295) || (2130706432<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2147483647) || (2886729728<$ipblocker_ban['forwaded_for_ip_coded'] && $ipblocker_ban['forwaded_for_ip_coded']<2887778303))
			$ipblocker_ban['forwaded_for_ip_coded'] = $ipblocker_ban['ip_coded'];
		else
			$ipblocker_ban['forwaded_for_hostname'] = gethostbyaddr($ipblocker_ban['forwaded_for_ip']);
		if($ipblocker_ban['ip_coded'] != $ipblocker_ban['forwaded_for_ip_coded'])
			$ipblocker_ban['using_proxy'] = true;
		else
			$ipblocker_ban['using_proxy'] = false;
	}
}
//end ip finding

//if total_logging is enabled: log every data-ip-page-system
if($ipblocker_config['total_logging']){
	if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
		$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." (original ip:".$ipblocker_ban['forwaded_for_ip'].") - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
	else
		$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
	
	//write to the log
	ipblocker_filelogger($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'], $ipblocker_config['string']);

	//file splitting routine
	if(filesize($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename']) > $ipblocker_config['total_logging_filesize'] && $ipblocker_config['total_logging_filesize'] > 0){
		$ipblocker_config['fp'] = @fopen($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'],"r") or die("Error opening/creating the total logger file! cannot proceed");
		@fseek($ipblocker_config['fp'], filesize($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'])-$ipblocker_config['total_logging_filesize']);
		$content = @fread($ipblocker_config['fp'], $ipblocker_config['total_logging_filesize']) or die("Error reading the total logger file! cannot proceed");
		@fclose($ipblocker_config['fp']);
		@unlink($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename']);
		$content = implode("\n",array_slice(explode("\n",$content), 1));
		$ipblocker_config['fp'] = fopen($ipblocker_config['fullpathLogName'].$ipblocker_config['total_logging_filename'],"w") or die("Error opening/creating the total logger file! cannot proceed");
		@fwrite($ipblocker_config['fp'], $content) or die("Unable to write the total logger file! cannot proceed");
		@fclose($ipblocker_config['fp']) or die("Unable to close the total logger file! cannot proceed");
		unset($content);
	}
	//splitting routine ended
}
//end total_logging

//connecting to mysql server
ipblocker_connect();

//controlling if the ip is banned
if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
	$ipblocker_query_result = @mysql_query("SELECT rangename FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".$ipblocker_ban['ip_coded']."' AND end >= '".$ipblocker_ban['ip_coded']."' OR start <= '".$ipblocker_ban['forwaded_for_ip_coded']."' AND end >= '".$ipblocker_ban['forwaded_for_ip_coded']."' LIMIT 1", $ipblocker_config['connection_link']) or die("The phpipblocker script wasn't able to query the database...<br /><br />Inform the admin: ".$ipblocker_config['adminMail']);
else
	$ipblocker_query_result = @mysql_query("SELECT rangename FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".$ipblocker_ban['ip_coded']."' AND end >= '".$ipblocker_ban['ip_coded']."' LIMIT 1", $ipblocker_config['connection_link']) or die("The phpipblocker script wasn't able to query the database...<br /><br />Inform the admin: ".$ipblocker_config['adminMail']);

//main blocking routine
if(@mysql_num_rows($ipblocker_query_result) > 0){
	$ipblocker_query_result = @mysql_fetch_array($ipblocker_query_result);
	
	//remove slashes
	//if (!get_magic_quotes_gpc())
		$ipblocker_ban['rangename'] = stripslashes($ipblocker_query_result['rangename']);
	
	if($ipblocker_config['sendMail'] && ((!empty($ipblocker_config['notNotifyMail']) && !eregi($ipblocker_config['notNotifyMail'],  $ipblocker_ban['rangename'])) || empty($ipblocker_config['notNotifyMail']))){
		$ipblocker_ban['mail_headers'] = "From: ".$ipblocker_config['adminMail']." <".$ipblocker_config['adminMail'].">\nReply-To: ".$ipblocker_config['adminMail']."\n\n";
		
		//check if the referer is available or not
		if(isset($_SERVER['HTTP_REFERER']))
			$ipblocker_ban['referer'] = $_SERVER['HTTP_REFERER'];
		else
			$ipblocker_ban['referer'] = "";
		
		$ipblocker_ban['mail_text'] = $ipblocker_ban['rangename']." has been tracked while visiting your website\n\nIp that requested the page: ".$ipblocker_ban['ip']."\nHostname: ".$ipblocker_ban['hostname']."\n\nDate: ".date($ipblocker_config['date_format'])."\nRequired Page: ".$_SERVER['REQUEST_URI']."\nClient Port used: ".$_SERVER['REMOTE_PORT']."\nUsed method: ".$_SERVER['REQUEST_METHOD']."\nReferer: ".$ipblocker_ban['referer']."\nSystem: ".$_SERVER['HTTP_USER_AGENT']."\n\n";
		if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_ban['mail_text'] .= "Using Transparent proxy = yes\nOriginal IP (declared by the proxy: not 100% affidable): ".$ipblocker_ban['forwaded_for_ip']."\nOriginal Hostname (declared by the proxy: not 100% affidable): ".$ipblocker_ban['forwaded_for_hostname']."\n";
		elseif(!$ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_ban['mail_text'] .= "Using Transparent proxy = no\n";
		$ipblocker_ban['mail_object'] = "[phpipblocker] ".$ipblocker_ban['rangename']." on your website";
		mail($ipblocker_config['adminMail'], $ipblocker_ban['mail_object'], $ipblocker_ban['mail_text'], $ipblocker_ban['mail_headers']);
	}
	if($ipblocker_config['logAccess'] && ((!empty($ipblocker_config['notLogRanges']) && !eregi($ipblocker_config['notLogRanges'],  $ipblocker_ban['rangename'])) || empty($ipblocker_config['notLogRanges']))){
		if($ipblocker_ban['using_proxy'] && $ipblocker_config['proxyCheck'])
			$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." (original ip:".$ipblocker_ban['forwaded_for_ip'].") - ".$ipblocker_ban['rangename']." - ".$_SERVER['REQUEST_URI']." -".$_SERVER['HTTP_USER_AGENT']."\n";
		else
			$ipblocker_config['string'] = "".date($ipblocker_config['date_format'])." - ".$ipblocker_ban['ip']." - ".$ipblocker_ban['rangename']." - ".$_SERVER['REQUEST_URI']." - ".$_SERVER['HTTP_USER_AGENT']."\n";
		switch($ipblocker_config['logFrequency']){
			case "day":
				ipblocker_filelogger($ipblocker_config['fullpathLogName']."".date("Y")."".date("m")."".date("d").".log", $ipblocker_config['string']);
				break;
			case "week":
				ipblocker_filelogger($ipblocker_config['fullpathLogName']."".date("Y")."".date("W").".log", $ipblocker_config['string']);
				break;
			case "month":
				ipblocker_filelogger($ipblocker_config['fullpathLogName']."".date("Y")."".date("m").".log", $ipblocker_config['string']);
				break;
			case "year":
				ipblocker_filelogger($ipblocker_config['fullpathLogName']."".date("Y").".log", $ipblocker_config['string']);
				break;
			default:
				ipblocker_filelogger($ipblocker_config['fullpathLogName']."".$ipblocker_config['logFrequency'], $ipblocker_config['string']);
				break;
		}
	}
	if($ipblocker_config['blockThem']){
		switch($ipblocker_config['blockType']){
			case 0:
				ipblocker_disconnect();
				header ("HTTP/1.1 404 Not Found");
				exit();
				break;
			case 1:
				ipblocker_disconnect();
				header ("HTTP/1.1 403 Forbidden");
				exit();
				break;
			case 2:
				ipblocker_disconnect();
				header ("Location: ".$ipblocker_config['blockRedirectURL']);
				exit();
				break;
			case 3:
				ipblocker_disconnect();

				//for security purpose we cleanup all the config options
				$ipblocker_ban['admin_mail'] = $ipblocker_config['adminMail'];
				unset($ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion);

				//build the replacements arrays				
				$ipblocker_ban['template_in'] = array("_adminMail_plain_","_adminMail_encoded_","_rangename_","_ip_","_hostname_","_forwaded_for_ip_","_forwaded_for_hostname_");
				$ipblocker_ban['template_out'] = array($ipblocker_ban['admin_mail'], ipblocker_encode_mail($ipblocker_ban['admin_mail']), $ipblocker_ban['rangename'], $ipblocker_ban['ip'], $ipblocker_ban['hostname'], $ipblocker_ban['forwaded_for_ip'], $ipblocker_ban['forwaded_for_hostname']);
				//load the template
				$ipblocker_ban['stop_text'] = implode('', file(_phpipblocker_dir_."template.html"));
				$ipblocker_ban['stop_text'] = addslashes($ipblocker_ban['stop_text']);
				//fill the template
				$ipblocker_ban['stop_text'] = str_replace($ipblocker_ban['template_in'], $ipblocker_ban['template_out'], $ipblocker_ban['stop_text']);
				$ipblocker_ban['stop_text'] = "\$ipblocker_ban['stop_text']=\"".$ipblocker_ban['stop_text']."\";";
				eval($ipblocker_ban['stop_text']);
				$ipblocker_ban['stop_text'] = stripslashes($ipblocker_ban['stop_text']);
				//print the message
				die($ipblocker_ban['stop_text']);
				break;
		}
	}
}

//disconnect from mysql server (only if it's needed)
ipblocker_disconnect();

//clean up the memory used ^_'
unset($ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion, $ipblocker_ban, $ipblocker_query_result);

//END SCRIPT CODE

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>