<?PHP
/**************************** php ipblocker ****************************
*                     http://phpipblocker.evcz.tk                      *
*                             version 0.99f                            *
*                                                                      *
*     developed by EvolutionCrazy (AKA evcz) for B.I.S.S. forum ;)     *
*                             evcz@evcz.tk                             *
*                                                                      *
*    Script distributed under GNU/GPL license (version 2 or higher)    *
*                                                                      *
*                   comments and suggestions here:                     *
*       http://www.bluetack.co.uk/forums/index.php?showforum=156       *
*                                                                      *
***********************************************************************/

//security addons
if(!defined('_phpipblocker_dir_'))
	die("You can't access this file!");

//function to connect to the sql server
function ipblocker_connect(){
	global $ipblocker_config;

	//connect
	if($ipblocker_config['persistent'])
		$ipblocker_config['connection_link'] = @mysql_pconnect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die("The phpipblocker script wasn't able to connect to the mysql server (persistent connection)...<br /><br />Inform the admin: ".$ipblocker_config['adminMail']);
	else
		$ipblocker_config['connection_link'] = @mysql_connect($ipblocker_config['db_server'], $ipblocker_config['db_user'], $ipblocker_config['db_pass']) or die("The phpipblocker script wasn't able to connect to the mysql server...<br /><br />Inform the admin: ".$ipblocker_config['adminMail']);

	//select the database
	if($ipblocker_config['mysql_compatibility'])
		$ipblocker_config['db_table_name'] = "".$ipblocker_config['db_name'].".".$ipblocker_config['db_table_name']."";
	else
		@mysql_select_db($ipblocker_config['db_name'], $ipblocker_config['connection_link']) or die("The phpipblocker script wasn't able to select the correct database...<br /><br />Inform the admin: ".$ipblocker_config['adminMail']);

}

//function to disconnect from the sql server
function ipblocker_disconnect(){
	global $ipblocker_config;
	
	//disconnect
	if(!$ipblocker_config['persistent'] && $ipblocker_config['disconnect'])
		@mysql_close($ipblocker_config['connection_link']);

}

//function to encode emails
function ipblocker_encode_mail($email){
	$email = str_replace(".", "<!-- encoded --><b></b>&nbsp;[<!-- encoded -->d<!-- encoded -->o<!-- encoded -->t<!-- encoded -->]&nbsp;<b></b><!-- encoded -->", $email);
	$email = str_replace("@", "<!-- encoded --><b></b>&nbsp;[<!-- encoded -->a<!-- encoded -->t<!-- encoded -->]&nbsp;<b></b><!-- encoded -->", $email);
	return $email;
}

function ipblocker_list_format($line){
	if(eregi("^(.*):([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})-([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3})$", $line))
		return "protowall";
	elseif(eregi("^([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}) - ([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}).([0-9]{1,3}) , ([0-9]{1,5}) , (.*)$", $line))
		return "donk";
	else
		return "unknown";
}

function ipblocker_line_decode($line, $list_format){
	switch($list_format){
		case "protowall":
			$arr_line = explode(':', $line);
			$range_ip = explode("-", $arr_line[(count($arr_line)-1)]);
			$data['rangename'] = implode(':', array_splice($arr_line, 0, count($arr_line)-1));
			$data['start'] = "".$range_ip['0']."";
			$data['end'] = "".$range_ip['1']."";
			return $data;
			break;
		case "donk":
			$arr_line = explode(' , ', $line);
			$range_ip = explode(" - ", $arr_line['0']);
			$data['rangename'] = implode(' , ', array_splice($arr_line, 2, count($arr_line)));
			$data['start'] = "".$range_ip['0']."";
			$data['end'] = "".$range_ip['1']."";
			return $data;
			break;
	}
}
	

function ipblocker_fillTable(){
	global $ipblocker_config, $ipblocker_listLocation, $ipblocker_exclusion;
	
	//start timer
	$mtime = microtime();
	$mtime = explode(" ",$mtime);
	$mtime = $mtime[1] + $mtime[0];
	$start_time = "".$mtime;
	//timer
	
	$stats['lists_number'] = 0;
	$stats['lists_skipped'] = 0;
	$stats['rules_number'] = 0;
	
	//empty the table
	@mysql_query("TRUNCATE ".$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']);
	
	//inizialize the counter
	$i = 0;
	
	//inizialize query string for uniquer_query mode
	if($ipblocker_config['unique_query'])
		$query = "INSERT INTO ".$ipblocker_config['db_table_name']." (`start`,`end`,`rangename`) VALUES ";
	
	//read and import a list at once
	foreach ($ipblocker_listLocation as $m => $fileLocation){
		$stats['lists_number']++;

		//intial format list values
		$format_checked = false;
	
		$lines = gzfile("".$fileLocation."") or die("Unable to load <b>".$fileLocation."</b>... process stopped!");
		foreach ($lines as $k => $line){

			//remove newlines at the end
			$line = rtrim($line);

			//check what type of list we are using
			if(!$format_checked){
				$list_format = ipblocker_list_format($line);
				$format_checked = true;
			}
			
			//if the format of the list is unsupported we skip this list
			if($list_format == "unknown"){
				$stats['lists_skipped']++;
				$stats['lists_number']--;
				break;
			}
			
			//decode the line according to the routine related to the list type in use
			$data = ipblocker_line_decode($line, $list_format);
			$stats['rules_number']++;			
			
			//add slashes
			//if (!get_magic_quotes_gpc())
				$data['rangename'] = addslashes($data['rangename']);
			
			if($ipblocker_config['unique_query']){
				if($i != 0)
					$query .= ",";
				$query .=  "('".sprintf("%u", ip2long($data['start']))."','".sprintf("%u", ip2long($data['end']))."','".$data['rangename']."')";
				
				$i++;
				
				if($i == $ipblocker_config['lines_per_query']){
					@mysql_query($query, $ipblocker_config['connection_link']);
					$query = "INSERT INTO ".$ipblocker_config['db_table_name']." (`start`,`end`,`rangename`) VALUES ";
					$i = 0;
				}
			}
			
			else
				@mysql_query("INSERT INTO ".$ipblocker_config['db_table_name']." (`start`,`end`,`rangename`) VALUES ('".sprintf("%u", ip2long($data['start']))."','".sprintf("%u", ip2long($data['end']))."','".$data['rangename']."')", $ipblocker_config['connection_link']);
		}
	}
	if($ipblocker_config['unique_query']){
		@mysql_query($query, $ipblocker_config['connection_link']);
	}
	//finished importing the lists
	
	//exclusion lists process
	$stats['exclusions_rules_number'] = 0;
	if(isset($ipblocker_exclusion)){
		foreach ($ipblocker_exclusion as $m => $fileLocation){

			//intial format list values
			$format_checked = false;
			
			$stats['lists_number']++;
			$lines = gzfile("".$fileLocation."") or die("Unable to load <b>".$fileLocation."</b>... process stopped!");
			foreach ($lines as $k => $line){
				//remove newlines at the end
				$line = rtrim($line);
	
				//check what type of list we are using
				if(!$format_checked){
					$list_format = ipblocker_list_format($line);
					$format_checked = true;
				}
				
				//if the format of the list is unsupported we skip this list
				if($list_format == "unknown"){
					$stats['lists_skipped']++;
					$stats['lists_number']--;
					break;
				}
				
				//decode the line according to the routine related to the list type in use
				$data = ipblocker_line_decode($line, $list_format);

				$stats['exclusions_rules_number']++;				
				
				//add slashes
				//if (!get_magic_quotes_gpc())
				$data['rangename'] = addslashes($data['rangename']);
			
				$start = sprintf("%u", ip2long($data['start']));
				$end = sprintf("%u", ip2long($data['end']));
				
				//search for encapsulated ranges
				$result = @mysql_query("SELECT * FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".$start."' AND end >= '".$end."'", $ipblocker_config['connection_link']);
				if(mysql_num_rows($result) > 0){
					while($result_fetched = mysql_fetch_array($result)){
						//same start different end
						//exclusion_start = start < exclusion_end < end
						if($result_fetched['start'] == $start && $result_fetched['end'] != $end)
							@mysql_query("UPDATE ".$ipblocker_config['db_table_name']." SET start = '".($end+1)."' WHERE start = '".$result_fetched['start']."' AND end = '".$result_fetched['end']."'", $ipblocker_config['connection_link']);
						//different start, same end
						//start < exclusion_start < end = exclusion_end
						elseif($result_fetched['start'] != $start && $result_fetched['end'] == $end)
							@mysql_query("UPDATE ".$ipblocker_config['db_table_name']." SET end = '".($start-1)."' WHERE start = '".$result_fetched['start']."' AND end = '".$result_fetched['end']."'", $ipblocker_config['connection_link']);
						//start and end different
						//start < exclusion_start <= exclusion_end < end
						else{
							@mysql_query("UPDATE ".$ipblocker_config['db_table_name']." SET end = '".($start-1)."' WHERE start = '".$result_fetched['start']."' AND end = '".$result_fetched['end']."'", $ipblocker_config['connection_link']);
							@mysql_query("INSERT INTO ".$ipblocker_config['db_table_name']." (`start`,`end`,`rangename`) VALUES ('".($end+1)."','".$result_fetched['end']."','".addslashes(stripslashes($result_fetched['rangename']))."')", $ipblocker_config['connection_link']);
						}
					}
				}
				//ended encapsulated ranges
				
				//ITA: maggiore sia a destra che a sinistra (anche coincidenti)
				//exclusion_start <= start < end <= exclusion_end
				@mysql_query("DELETE FROM ".$ipblocker_config['db_table_name']." WHERE start >= '".$start."' AND end <= '".$end."'", $ipblocker_config['connection_link']);
				//end
				
				//ITA: maggiore a destra, interno a sinistra
				//start < exclusion_start < end < exclusion_end
				$result = @mysql_query("SELECT start, end FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".$start."' AND end >= '".$start."' AND end < '".$end."'", $ipblocker_config['connection_link']);
				if(mysql_num_rows($result) > 0){
					while($result_fetched = mysql_fetch_array($result)){
						@mysql_query("UPDATE ".$ipblocker_config['db_table_name']." SET end = '".($start-1)."' WHERE start = '".$result_fetched['start']."' AND end = '".$result_fetched['end']."'", $ipblocker_config['connection_link']);
					}
				}
				//end

				//ITA: minore a sinistra, interno a destra
				//exclusion_start < start < exclusion_end < end
				$result = @mysql_query("SELECT start, end FROM ".$ipblocker_config['db_table_name']." WHERE start <= '".$end."' AND end >= '".$end."' start > '".$start."'");
				if(@mysql_num_rows($result) > 0){
					while($result_fetched = mysql_fetch_array($result)){
						@mysql_query("UPDATE ".$ipblocker_config['db_table_name']." SET start = '".($end+1)."' WHERE start = '".$result_fetched['start']."' AND end = '".$result_fetched['end']."'");
					}
				}
				//end
			}
		}
	}
	//finished exclusions process

	//optimize the table
	@mysql_query("OPTIMIZE TABLE ".$ipblocker_config['db_table_name'], $ipblocker_config['connection_link']);

	//count real number of rows	
	$sql_rows = @mysql_query("SELECT COUNT(*) FROM ".$ipblocker_config['db_table_name']." WHERE 1", $ipblocker_config['connection_link']);
	$sql_rows = @mysql_fetch_array($sql_rows);
	$stats['sql_rows'] = "".$sql_rows['0']."";
	
	//end timer
	$mtime = microtime();
	$mtime = explode(" ",$mtime);
	$mtime = $mtime[1] + $mtime[0];
	$end_time = $mtime;
	//timer
	
	$stats['time'] = round($end_time-$start_time,3);

	return $stats;
}

//file logging function
function ipblocker_filelogger($file, $line){
	if(!$fp = @fopen($file, "a")) return FALSE;
	if(!@fwrite($fp, $line)) return FALSE;
	if(!@fclose($fp)) return FALSE;
	return TRUE;
}

/**********************************************************************
* This script is free software; you can redistribute it and/or        *
* modify it under the terms of the GNU Lesser General Public          *
* License as published by the Free Software Foundation.               *
*                                                                     *
* This script is distributed in the hope that it will be useful,      *
* but WITHOUT ANY WARRANTY; without even the implied warranty of      *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU   *
* Lesser General Public License for more details.                     *
*                                                                     *
* You should have received a copy of the GNU Lesser General Public    *
* License along with this script; if not, write to the                *
* Free Software Foundation, Inc.,                                     *
* 59 Temple Place, Suite 330,                                         *
* Boston, MA                                                          *
* 02111-1307                                                          *
* USA                                                                 *
*                                                                     *
* For further information, visit www.gnu.org                          *
**********************************************************************/

?>